#ifndef E_MOD_MAIN_H
#define E_MOD_MAIN_H

#include <e.h>
#include <Ecore.h>
#include "color_editor.h"
#include "font_editor.h"
#include "main_editor.h"

#define CALENDAR_CONFIG_VERSION 400

typedef struct _Config      Config;
typedef struct _calendar       Calendar;
typedef struct _calendar_Face  Calendar_Face;
typedef struct _calfonts	CalFonts;
typedef struct _ColorArray	c_array;

struct _calfonts
{
	int size; //Evas_Font_Size size; /**< Units to descript font sizes. Normally a double, but may vary platforms */ 
	char *font;
	Calendar *calendar;
};
struct _ColorArray
{
	Calendar *calendar;
	int red, red_o, red_s;
 	int green, green_o, green_s;
	int blue, blue_o, blue_s;
	int alpha, alpha_o, alpha_s;
};
/* color list -> red, green, blue, alpha, outline red, green, blue, alpha, shadow red, green, blue, alpha */

struct _Config
{
   Evas_List *faces;
   int ImageYes;
   int Today;
   int config_version;
   Evas_List *Today_s_text_colors;	
   Evas_List *Today_s_back_colors; 
   Evas_List *Weekend_text_colors;
   Evas_List *Weekend_back_colors; 
   Evas_List *WeekDay_text_colors; 
   Evas_List *WeekDay_back_colors;
   Evas_List *YearMon_numb_colors;
   Evas_List *DayWeek_text_colors;
   Evas_List *YM_text_class;
   Evas_List *Day_text_class;
   Evas_List *text_class;
   int DayofWeek_Start;
   char *TopImage_path;
   char *Background_path;
   char *ConfigFile_path;
   char *weekend_path;
   char *today_path;
   char *weekday_path;
   char *label_path;
   int UserCS;
};

struct _calendar
{
   Evas_List   *faces;
   E_Menu      *config_menu;
   Ecore_Timer *date_check_timer;
   Config      *conf;
};

struct _calendar_Face
{
  E_Container *con;
  E_Menu      *menu;
  E_Menu      *sub;
  E_Menu      *sub2;
  E_Menu      *sub3;
  Evas_Object *calendar_object;
  E_Gadman_Client *gmc;
  Evas_Object *topimage_object;
  Evas_Object *background_object;
  Evas_Object *table_object;
  Evas_Object *o_calendar_table;
  Evas_Object *weekday_object[35];
  Evas_Object *weekend_object[35];
  Evas_Object *today_object[35];
  Evas_Object *label_object;
};



EAPI void  redraw_calendar(Calendar *calendar, int SwitchImage);
EAPI void *e_modapi_init     (E_Module *m);
EAPI int   e_modapi_shutdown (E_Module *m);
EAPI int   e_modapi_save     (E_Module *m);
EAPI int   e_modapi_info     (E_Module *m);
EAPI int   e_modapi_about    (E_Module *m);

#include "calendar_color_func.h"
#include "calendar_text_fun.h"
#include "dialog_func.h"


#endif
